﻿@*wot.dadang 26/11/2012*@

@using Portal.Models;
@using System.Web.Mvc;
@using System.Web.UI.WebControls;
@using System.Data;
@using Portal.Controllers;
              
@model Toyota.Common.Web.MVC.ModelHolder
           
@{     
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

@section Style{

}

@section Script{
    

}
<script src="@Url.Content("~/Scripts/MicrosoftAjax.js")" type="text/javascript"></script>
<script src="@Url.Content("~/Scripts/MicrosoftMvcValidation.js")" type="text/javascript"></script>

<script type="text/javascript">
    var VCurr="";
    var Docdate="";
    var Cid = "";

    $( document ).ready(function() {
        txtCertificateID.SetFocus();
    });

    function OnBeginCallback(s, e) {
        e.customArgs["CertificateID"] = txtCertificateID.GetText();
    }

    function OnAccept(s, e){
        GridCounterReceiving.PerformCallback();
    }

    function CheckID(s, e) {  
        if(Cid == "") Cid = txtCertificateID.GetText();

        var prefixCid_Text = txtCertificateID.GetText();
        var prefixCid = prefixCid_Text.substring(prefixCid_Text.length-1,prefixCid_Text.length);
        if(prefixCid == "A") 
        {
            txtCertificateID.SetEnabled(false);
            SubmitData('Accept');
            txtCertificateID.SetEnabled(true);   
            txtCertificateID.Focus();                    
        }
        else if(prefixCid == "R") 
        {
            txtCertificateID.SetEnabled(false);
            SubmitData('Reject');
            txtCertificateID.SetEnabled(true);   
            txtCertificateID.Focus();         
        }
        else{
            PopupProgressBarCR.Show();        
        
            if (Cid != "") {
                txtCertificateID.SetEnabled(false);
                btnDownload.SetEnabled(false);
                //---=== get Data
                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/CounterReceiving/GetDataHeader")",
                    async: false,
                    data: {
                        CertificateId :Cid
                    },
                    success: function (result) {
                        PopupProgressBarCR.Hide();
                        ShowData(result);
                        txtCertificateID.SetEnabled(true);
                        txtCertificateID.Focus();
                    },
                    error: function (result) {
                        PopupProgressBarCR.Hide();
                        alert(result);
                    }
                });
                //---=== End ajax get data
            }
            btnDownload.SetEnabled(true);
        }
    }

    function CheckIDPress(s, e) {
        if (e.htmlEvent.keyCode == ASPxKey.Enter) {
            CheckID();
        }
    }

    function ShowData(getdata) {
         ClearHeader();  

        if ((getdata!='Data Not Found') && (getdata != 'Invoice Already Canceled')) {
             var dt = getdata.split(';');
             var sta = dt[7];
             if (sta == "2" || sta == "-2") {
                 var curen = dt[6];
                 VCurr = dt[6];
                 SupplierName.SetText(dt[0] + '' + dt[1]);
                 InvoiceNo.SetText(dt[2]);
                 InvoiceTaxNo.SetText(dt[4]);   
                 // check if usd currency

                 if (curen == "USD" ) {
                             var invoicemount = curen + ' ' + parseFloat(dt[3]).toFixed(2).replace(/(\d)(?=(\d\d\d)+(?!\d))/g, "$1,");
                             InvoiceAmount.SetText(invoicemount);
                             var taxamount = curen + ' ' + parseFloat(dt[5]).toFixed(2).replace(/(\d)(?=(\d\d\d)+(?!\d))/g, "$1,");
                             InvoiceTaxamount.SetText(taxamount);
                    }
                 else {
                            var invoicemount = curen + ' ' + parseFloat(dt[3]).toFixed(0).replace(/(\d)(?=(\d\d\d)+(?!\d))/g, "$1,");
                            InvoiceAmount.SetText(invoicemount);
                            var taxamount = curen + ' ' + parseFloat(dt[5]).toFixed(0).replace(/(\d)(?=(\d\d\d)+(?!\d))/g, "$1,");
                            InvoiceTaxamount.SetText(taxamount);
                 }
                 Createdby.SetText(dt[9]);
                 Docdate = dt[8];
                 Acceptbtn.SetEnabled(true);
                 Reject.SetEnabled(true); 
              }
              else { 
                 var pesan="";
                   switch(sta)
                    {
                      case "-5":
                            pesan ="Error Posting"; 
                            break;
                      case "-4":
                            pesan ="Reversed"
                            break;
                      case "-3":
                            pesan ="Cancelled";
                            break;
                      case "-1":
                            pesan ="Error Upload"
                            break;
                      case "1":
                            pesan ="Outstanding GR";
                            break;
                      case "3":
                            pesan ="Submitted";
                            break;
                      case "4":
                            pesan ="Posted"; 
                            break;
                      case "5":
                            pesan ="Paid"
                            break;
                    }
                   alert('Invoice With Status : ' + pesan + ' Cannot Be Receipt');
                   Cid = "";
              }
          }
        else {
                alert(getdata);
                txtCertificateID.SetFocus();
                Cid = "";
        }
    }
  
    function ClearHeader() {
        Docdate="";
        VCurr="";
        SupplierName.SetText('');
        Createdby.SetText('');
        InvoiceNo.SetText('');
        InvoiceTaxNo.SetText('');
        InvoiceAmount.SetText('');
        InvoiceTaxamount.SetText('');
        Acceptbtn.SetEnabled(false);
        Reject.SetEnabled(false);
    }

    function CheckReason(s, e) {
        var reject = RejectTxt.GetText();
        if (reject =='') 
            alert('Reason Must Be Write');
        else 
            SubmitData('Reject');
    }

    function Approve(s, e) {
        var CerId = txtCertificateID.GetText();
        if (CerId !='' ) {
            SubmitData('Accept');
        }
    }
   
function Download(s, e) {
  var HVCerID = document.getElementById('GridCounterReceiving_DXFREditorcol0_I').value;
  if (HVCerID =='') HVCerID='0';
  var HVSuppName = document.getElementById('GridCounterReceiving_DXFREditorcol2_I').value;
  if (HVSuppName=='') HVSuppName='0';
  var HVInvNo = document.getElementById('GridCounterReceiving_DXFREditorcol3_I').value;
  if (HVInvNo=='') HVInvNo='0';
  var HVInvAmt = document.getElementById('GridCounterReceiving_DXFREditorcol5_I').value;
  if (HVInvAmt=='') HVInvAmt=0;
  var HVInvTaxNo = document.getElementById('GridCounterReceiving_DXFREditorcol6_I').value;
  if (HVInvTaxNo=='') HVInvTaxNo='0';
  var HVInvTaxAmt = document.getElementById('GridCounterReceiving_DXFREditorcol7_I').value;
  if (HVInvTaxAmt=='') HVInvTaxAmt=0;
  var HVDate = document.getElementById('GridCounterReceiving_DXFREditorcol8_I').value;
  if (HVDate=='') HVDate='0';
  var HVSubmitBy = document.getElementById('GridCounterReceiving_DXFREditorcol9_I').value; 
  if (HVSubmitBy=='') HVSubmitBy='0';
        btnDownload.SetEnabled(false);
            //---=== get Data
             $.fileDownload("CounterReceiving/Downloadxls/", {
            data:{
                    CerID: HVCerID,
                    Suppcode: HFSuppCode.GetText(),
                    SuppName : HVSuppName,
                    InvNo : HVInvNo,
                    InvAmt : HVInvAmt,
                    InvTaxNo : HVInvTaxNo,
                    InvTaxAmt : HVInvTaxAmt,
                    HFDate : HVDate,
                    Curr: HFCurr.GetText(),
                    SubmitBy : HVSubmitBy,
                    Status: HFStatus.GetText()
                },
            successCallback: function(url) {
            },
            failCallback: function(responseHtml, url) {
		        alert(responseHtml);
            }
});
//            //---=== End ajax get data
             btnDownload.SetEnabled(true);
  }

    function Reject(s, e) {
        var CerId = txtCertificateID.GetText();
        if (CerId !='' ) {
            CounterReceivingpopup.Show();
        }
    }

    function SubmitData(message, s , e) {
        var alasan = "";
        var checkStatusResult = 0;
        
        Acceptbtn.SetEnabled(false);
        Reject.SetEnabled(false);
        btnDownload.SetEnabled(false);
        PopupProgressBarCR.Show();
        
        if(message == "Accept"){
            status = "3";
        }
        if(message == "Reject") {
            status = "-2";
            alasan = RejectTxt.GetText();
        }

        
        var supplierName = SupplierName.GetText();
        var supplierCd = supplierName.split(':');
        supplierCd = supplierCd[0];

        $.ajax({
            type: "POST",
            url: "@Url.Content("~/CounterReceiving/checkStatusInvoice")",
            async: false,
            data :
                {
                    supplier: supplierCd,
                    invoiceNo: InvoiceNo.GetText(),
                    invoiceTaxNo: InvoiceTaxNo.GetText()
                },
            success: function (result)
            {
                if ((result == 'exist') || (result == 'datanotexists')) {
                    checkStatusResult = 1; //data cant be accept or reject
                    alert(result == 'exist' ? 'Data not valid.' : 'Data Not Exists in Invoice Upload');

                    ClearHeader();
                    PopupProgressBarCR.Hide();
                    GridCounterReceiving.PerformCallback();
                    Cid = "";
                    txtCertificateID.SetText('');
                    txtCertificateID.SetFocus();

                } else {
                    if (result == 'SUCCESS') {
                        //checkStatusResult = 1;
                        //alert('Please process invoice posting manually');
                        $("#CRIMessageLabel").text("Invoice Posting Manually.");
                        CounterReceivingInformationPopup.Show();
                       /* ClearHeader();
                        PopupProgressBarCR.Hide();
                        GridCounterReceiving.PerformCallback();
                        Cid = "";
                        txtCertificateID.SetText('');
                        txtCertificateID.SetFocus(); */
                    }
                }
            },
            error: function (result)
            {
                alert('Error When Check Status Data.');
            }
        });

        if (checkStatusResult !== 1) {
            //alert("submit data run");
      
            $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/CounterReceiving/SubmitData")",
                async: false,
                data:
                {
                    CertificateID: Cid,
                    Reason: alasan,
                    Supplier: SupplierName.GetText(),
                    InvoiceNo: InvoiceNo.GetText(),
                    InvoiceTaxNo: InvoiceTaxNo.GetText(),
                    InvoiceAmount: InvoiceAmount.GetText().replace(VCurr, ""),
                    InvoiceTaxamount: InvoiceTaxamount.GetText().replace(VCurr, ""),
                    CreatedBy: Createdby.GetText(),
                    Curr: VCurr,
                    docdate: Docdate,
                    Sta: status
                },
                success: function (result) {
                    MessageAlert = "";
                    if (status == "3")
                        MessageAlert = "Data Successfully Accept";
                    if (status == "-2") {
                        MessageAlert = "Data Successfully Reject";
                        CounterReceivingpopup.Hide();
                    }
                    //alert(MessageAlert);
                    ClearHeader();
                    PopupProgressBarCR.Hide();
                    GridCounterReceiving.PerformCallback();
                    Cid = "";
                    txtCertificateID.SetText('');
                    txtCertificateID.SetFocus();
                },
                error: function (result) {
                    CounterReceivingpopup.Hide();
                    ClearHeader();
                    PopupProgressBarCR.Hide();
                    Cid = "";
                    txtCertificateID.SetText('');
                    txtCertificateID.SetFocus();
                    MessageAlert = "";
                    if (status == "3")
                        MessageAlert = "Data Unsuccessfully Approved";
                    if (status == "-2")
                        MessageAlert = "Data Unsuccessfully Rejected";
                    alert(MessageAlert);
                }
            });
            btnDownload.SetEnabled(true);
        }      
    }

    function OnCounterReceivingInformationPopupShown(s, e) {
        CounterReceivingInformationPopup.SetHeaderText("Invoice Posting Manually");
    }

    function OnCRIOkButtonClick(s, e) {
        CounterReceivingInformationPopup.Hide();
    }

</script>
<table cellpadding="0" cellspacing="0" width="100%">
    <tr>
        <td style="padding-right:8px;">
            <div style="border:1px solid  #4f93e3; background-color:#DEECFD; padding:10px; height:135px">
                @{
                    Html.RenderPartial("HeaderCounterReceiving");
                 }
            </div>
        </td>
        <td>
            <div style="border:1px solid  #4f93e3; background-color:#DEECFD; padding:10px; height:135px">
                @{
                    Html.RenderAction("PartialCounterReceivingDetail", "CounterReceiving");
                 }
            </div>
        </td>
    </tr>
</table>

<div style="height:8px;"></div>

@Html.Partial("CounterReceivingPartial", Model)

<div style="height:8px;"></div>

<table border="0" align="left" style="margin-left:-5px;">
    <tr>                   
        <td align="left" style=" padding-left:4px;">
        @Html.DevExpress().Button(
            settings =>
            {
                settings.Name = "btnDownload";
                settings.Text = "Download";
                settings.Width = 80;
                settings.UseSubmitBehavior = true;
                 settings.ClientSideEvents.Click = "Download";
                settings.ClientEnabled = true;
                settings.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
            }).GetHtml()
        </td>
    </tr>
</table>
@Html.DevExpress().PopupControl(settings => {
    settings.Name = "CounterReceivingpopup";
    settings.CloseAction = CloseAction.OuterMouseClick;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.ShowFooter = true;
    settings.AllowDragging = true;
    settings.EnableHotTrack = true;
    settings.Height = Unit.Pixel(300);
    settings.Width = Unit.Pixel(400);
   
    settings.PopupElementID = "Reject";
    settings.HeaderText = "Reject Confirmation";

    settings.SetContent(() => {
        Html.RenderAction("Preview","CounterReceiving");
    });

    settings.SetFooterTemplateContent(c => {
        ViewContext.Writer.Write("<div style=\"overflow: hidden\"><div style=\"padding: 3px; float: right;\">");
      
         ViewContext.Writer.Write("</div></div>");
    });
}).GetHtml()

@Html.Common().DevExpress().MessageBoard(
    msettings =>
    {
        msettings.Name = "CRMessageBoard";
        msettings.BoardName = "CounterReceiving";
        msettings.Position = MessageBoardPosition.RIGHT;
    }
).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "PopupProgressBarCR";
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.ShowShadow = true;
    settings.Modal = true;
    settings.CloseAction = CloseAction.None;
    settings.ShowHeader = false;
    settings.SetContent(() =>
    {
        Html.RenderPartial("PopupProgressBarCR");
    });
}).GetHtml()
@Html.DevExpress().LoadingPanel(
    settings =>
    {
        settings.Name = "LoadingPanelCR";
        settings.Modal = true;
        //settings.ContainerElementID = IsDisplayedOverPanel ? "Panel" : "";
    }).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "CounterReceivingInformationPopup";
    //settings.HeaderText = "Goods Receipt Inquiry Information";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(350);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(170);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnCounterReceivingInformationPopupShown";
    settings.SetContent(() =>
    {
        Html.RenderPartial("CounterReceivingInformationPopup", Model);
    });
}).GetHtml()